<script setup>
import { Head, Link, useForm } from '@inertiajs/vue3';
import AppLayout from '@/Layouts/AppLayout.vue';
import Select from '@/Components/Select.vue';
import InputError from '@/Components/InputError.vue';

const props = defineProps({
    id: null,
    created_at: null,
    updated_at: null,
    transacted_at: null,
    transacted: Boolean,
    number: String,
    product_transactions: {
        type: Array,
        default: [],
    },
    products: [Array, Object],
});

const form = useForm({
    ...props
})

function addProduct() {
    form.product_transactions.push({
        product_id: null,
        count: 0,
        price: 0,
        amount: 0,
    });
}

function delProduct(index) {
    form.product_transactions.splice(index, 1);
}

function onSubmit() {
    if (form.id) {
        form.put(route('product-incomes.update', form.id));
    } else {
        form.post(route('product-incomes.store'));
    }
}

function onTransact() {
    if (form.id) {
        form
            .transform(data => ({
                ...data,
                transacted: true,
            }))
            .put(route('product-incomes.update', form.id));
    } else {
        form
            .transform(data => ({
                ...data,
                transacted: true,
            }))
            .post(route('product-incomes.store'));
    }
}
</script>

<template>
    <Head title="Документы: Приход товаров"/>

    <AppLayout>
        <template #breadcrumb>
            Документы: Приход товаров / {{ props.id ? 'Изменеие' : 'Создание' }}
        </template>

        <div class="d-flex justify-content-between my-3">
            <div v-if="form.created_at" class="d-flex flex-row gap-2">
                <span>Создан</span>
                <span class="badge text-bg-secondary" v-text="form.created_at"/>
            </div>
            <div v-if="form.updated_at" class="d-flex flex-row gap-2">
                <span>Изменён</span>
                <span class="badge text-bg-secondary" v-text="form.updated_at"/>
            </div>
        </div>
        <form @submit.prevent="onSubmit">
            <fieldset :disabled="form.transacted">
                <div class="d-flex justify-content-between">
                    <div class="mb-3 position-relative">
                        <label for="name" class="form-label">Номер</label>
                        <input
                            v-model="form.number"
                            id="name"
                            type="text"
                            class="form-control w-auto"
                            :class="{'is-invalid': form.errors.number}"
                            @input="form.clearErrors('number')"
                        >
                        <InputError :message="form.errors.number" tooltip/>
                    </div>
                    <div class="mb-3 position-relative">
                        <label for="vendor_code" class="form-label">Дата проведения</label>
                        <input
                            v-model="form.transacted_at"
                            id="vendor_code"
                            type="datetime-local"
                            class="form-control w-auto"
                            :class="{'is-invalid': form.errors.transacted_at}"
                            @input="form.clearErrors('transacted_at')"
                        >
                        <InputError :message="form.errors.transacted_at" tooltip/>
                    </div>
                </div>

                <table class="table table-sm">
                    <thead>
                    <tr>
                        <th scope="col">Товар</th>
                        <th scope="col" style="width: 7rem;">Количество</th>
                        <th scope="col" style="width: 10rem;">Цена</th>
                        <th scope="col">Сумма</th>
                        <th scope="col" style="width: 1%;padding: 0;">
                            <button type="button" class="btn btn-sm border-0 d-flex mx-auto" @click="addProduct">
                                <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="currentColor" class="bi bi-plus-circle-fill text-success" viewBox="0 0 16 16">
                                    <path d="M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0zM8.5 4.5a.5.5 0 0 0-1 0v3h-3a.5.5 0 0 0 0 1h3v3a.5.5 0 0 0 1 0v-3h3a.5.5 0 0 0 0-1h-3v-3z"/>
                                </svg>
                            </button>
                        </th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr v-for="(item, index) in form.product_transactions" :key="index">
                        <td>
                            <div class="position-relative">
                                <Select
                                    v-model="item.product_id"
                                    scale="sm"
                                    :source="props.products"
                                    :invalid="Boolean(form.errors?.[`product_transactions.${index}.product_id`])"
                                    @change="delete form.errors?.[`product_transactions.${index}.product_id`]"
                                />
                                <InputError :message="form.errors?.[`product_transactions.${index}.product_id`]"/>
                            </div>
                        </td>
                        <td>
                            <div class="position-relative">
                                <input
                                    v-model="item.count"
                                    type="number"
                                    class="form-control form-control-sm"
                                    :class="{'is-invalid': Boolean(form.errors?.[`product_transactions.${index}.count`])}"
                                    @change="delete form.errors?.[`product_transactions.${index}.count`]"
                                >
                                <InputError :message="form.errors?.[`product_transactions.${index}.count`]"/>
                            </div>
                        </td>
                        <td>
                            <div class="position-relative">
                                <input
                                    v-model="item.price"
                                    type="number"
                                    class="form-control form-control-sm"
                                    :class="{'is-invalid': Boolean(form.errors?.[`product_transactions.${index}.price`])}"
                                    @change="delete form.errors?.[`product_transactions.${index}.price`]"
                                >
                                <InputError :message="form.errors?.[`product_transactions.${index}.price`]"/>
                            </div>
                        </td>
                        <td>
                            {{ (item.amount = item.count * item.price).toLocaleString() }}
                        </td>
                        <td>
                            <button @click="delProduct(index)" type="button" class="btn btn-sm border-0 d-flex">
                                <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="currentColor" class="bi bi-dash-circle-fill text-danger" viewBox="0 0 16 16">
                                    <path d="M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0zM4.5 7.5a.5.5 0 0 0 0 1h7a.5.5 0 0 0 0-1h-7z"/>
                                </svg>
                            </button>
                        </td>
                    </tr>
                    </tbody>
                </table>
                <div v-if="form.errors.product_transactions" class="invalid-feedback d-block">
                    {{ form.errors.product_transactions }}
                </div>


                <div class="d-flex justify-content-end gap-2">
                    <Link as="button" :href="route('product-incomes.index')" class="btn btn-secondary">Закрыть</Link>
                    <button type="submit" class="btn btn-warning">Сохранить</button>
                    <button type="button" @click="onTransact" class="btn btn-success">Провести</button>
                </div>
            </fieldset>
        </form>
    </AppLayout>
</template>
